﻿using static IC_Tester_Controls.MouseHook;

namespace IC_Tester_Controls
{
   /// <summary>
   /// Form zur Erfassung der Pin-Bezeichnung.
   /// </summary>
   /// <remarks>Wird zum Editieren des Vertical-Label benötigt.<para/>
   /// Eingabe mit 'Enter' oder 'Escape' abschließen, oder Mouseklick ausßerhalb des Forms. 
   /// </remarks>
   public partial class PinNameEditor : Form
   {
      /// <summary>Die eingegebene Bezeichnung des Pins.</summary>
      public String PinName { get; set; }

      /// <summary>
      /// Initialisiert eine neue Instanz der <see cref="PinNameEditor"/>-Klasse.
      /// </summary>
      public PinNameEditor()
      {
         InitializeComponent();
         PinName = "";
      }

      /// <summary>
      /// Initialisiert eine neue Instanz der <see cref="PinNameEditor"/>-Klasse.
      /// </summary>
      /// <param name="InitialValue">Initialwert.</param>
      public PinNameEditor(String InitialValue) : this()
      {
         PinName = InitialValue;
         tbPinName.Text = PinName;
      }

      private void tbPinName_KeyDown(object sender, KeyEventArgs e)
      {
         if (e.KeyCode == Keys.Enter)
         {
            PinName = tbPinName.Text;
            Close();
         }
         else if (e.KeyCode == Keys.Escape)
         {
            Close();
         }
      }

      private void PinNameEditor_Load(object sender, EventArgs e)
      {
         MouseHook.Start();
         MouseHook.MouseDown += MouseDownHandler;
         Height= tbPinName.Height;
      }

      private void MouseDownHandler(object? sender, MousHookEventArgs e) {
         try
         {
            var mousePos = PointToClient(new Point(e.X, e.Y));
            if (mousePos.X < 0 || mousePos.X > Width || mousePos.Y < 0 || mousePos.Y > Height)
            {
               PinName = tbPinName.Text;
               Close();
            }
         }
         catch (Exception)
         {
         }

      }

        private void PinNameEditor_FormClosing(object sender, FormClosingEventArgs e)
        {
         MouseHook.Stop();
        }
    }
}
